CREATE OR REPLACE VIEW idm_rpt_cfg.IDMRPT_RES_TRUST_V AS 
  SELECT  
    idmrpt_resource.res_id,
    COALESCE(idmrpt_resource.res_name, idmrpt_resource.res_dn) AS res_name,
    idmrpt_resource.res_dn,
    idmrpt_resource.res_desc,
    idmrpt_resource.idmrpt_syn_state,
        CASE
            WHEN lower(idmrpt_idv_identity_trust.cause_type) = lower('role driver') THEN (rela.role_name || ' -- ') || rela.role_descr
            ELSE NULL
        END AS role_name,
        CASE
            WHEN trim(idmrpt_rpt_driver.idv_host) = trim(idmrpt_rpt_driver.idv_name) THEN idmrpt_rpt_driver.idv_name
            ELSE ((idmrpt_rpt_driver.idv_name || ' (') || idmrpt_rpt_driver.idv_host) || ')'
        END AS idv_name1,
    idmrpt_identity.last_name,
    idmrpt_identity.first_name,
    idmrpt_identity.middle_initial,
    idmrpt_idv_identity_trust.trust_start_time,
    idmrpt_idv_identity_trust.trust_expiration_time,
    idmrpt_idv_identity_trust.idmrpt_valid_to,
    idmrpt_idv_identity_trust.idmrpt_valid_from,
    idmrpt_idv_identity_trust.identity_id,
    idmrpt_idv_identity_trust.requester_id,
    idmrpt_idv_identity_trust.trust_type_id,
    idmrpt_idv_identity_trust.idmrpt_deleted AS idm_rpt_deleted,
    ent.idmrpt_ent_dn ent_dn,
    ent.idmrpt_ent_name ent_name,
    driver.drv_dn driver_dn,
    driver.drv_name driver_name,
   'now'::text::date + 7305 + 'now'::text::time with time zone AS fake_future_date,
        CASE
            WHEN binding.ent_param_str::text ~~ '%ID2%'::text THEN ( SELECT idmrpt_ms_ent_cs_v.ms_ent_val_disp_name
               FROM idm_rpt_cfg.idmrpt_ms_ent_cs_v
              WHERE idmrpt_ms_ent_cs_v.ms_ent_val::text = "substring"(binding.ent_param_str::text, "position"(binding.ent_param_str::text, 'ID2'::text) + 6, "position"("substring"(binding.ent_param_str::text, "position"(binding.ent_param_str::text, 'ID2'::text) + 6), '}'::text) - 2))
            WHEN binding.ent_param_str::text ~~ '%ID%'::text THEN ( SELECT idmrpt_ms_ent_cs_v.ms_ent_val_disp_name
               FROM idm_rpt_cfg.idmrpt_ms_ent_cs_v
              WHERE idmrpt_ms_ent_cs_v.ms_ent_val::text = "substring"(binding.ent_param_str::text, "position"(binding.ent_param_str::text, 'ID'::text) + 5, "position"("substring"(binding.ent_param_str::text, "position"(binding.ent_param_str::text, 'ID'::text) + 5), '}'::text) - 2))
            WHEN binding.ent_param_str::text = '%EntitlementParamKey%'::text OR binding.ent_param_val::text = '%EntitlementParamKey%'::text THEN
            CASE
                WHEN idmrpt_idv_identity_trust.trust_params::text ~~ '%ID2%'::text THEN (( SELECT idmrpt_ms_ent_cs_v.ms_ent_val_disp_name
                   FROM idm_rpt_cfg.idmrpt_ms_ent_cs_v
                  WHERE idmrpt_ms_ent_cs_v.ms_ent_val::text = "substring"(idmrpt_idv_identity_trust.trust_params::text, "position"(idmrpt_idv_identity_trust.trust_params::text, 'ID2'::text) + 6, "position"("substring"(idmrpt_idv_identity_trust.trust_params::text, "position"(idmrpt_idv_identity_trust.trust_params::text, 'ID2'::text) + 6), '}'::text) - 2)))::text
                WHEN idmrpt_idv_identity_trust.trust_params::text ~~ '%ID%'::text THEN (( SELECT idmrpt_ms_ent_cs_v.ms_ent_val_disp_name
                   FROM idm_rpt_cfg.idmrpt_ms_ent_cs_v
                  WHERE idmrpt_ms_ent_cs_v.ms_ent_val::text = "substring"(idmrpt_idv_identity_trust.trust_params::text, "position"(idmrpt_idv_identity_trust.trust_params::text, 'ID'::text) + 5, "position"("substring"(idmrpt_idv_identity_trust.trust_params::text, "position"(idmrpt_idv_identity_trust.trust_params::text, 'ID'::text) + 5), '}'::text) - 2)))::text
                ELSE "substring"(idmrpt_idv_identity_trust.trust_params::text, "position"(idmrpt_idv_identity_trust.trust_params::text, 'EntitlementParamKey'::text) + 21, "position"("substring"(idmrpt_idv_identity_trust.trust_params::text, "position"(idmrpt_idv_identity_trust.trust_params::text, 'EntitlementParamKey'::text) + 21), '</value>'::text) - 1)
            END::character varying
            ELSE binding.ent_param_val
        END AS ent_value,
    ent.idv_ent_id,
    binding.ent_param_liid liid,
    idmrpt_resource.idmrpt_valid_to idmrpt_resource_valid_to,
    idmrpt_identity.idmrpt_valid_to idmrpt_identity_valid_to,
    idmrpt_identity.identity_id  idmrpt_identity_identity_id,
    ent.idmrpt_valid_to ent_idmrpt_valid_to,
    ent.idv_ent_id ent_idv_ent_id
FROM idm_rpt_cfg.idmrpt_rpt_driver_v idmrpt_rpt_driver,
    idm_rpt_cfg.idmrpt_idv_v idmrpt_idv,
    idm_rpt_cfg.idmrpt_identity_v idmrpt_identity,
    idm_rpt_cfg.idmrpt_idv_identity_trust_v idmrpt_idv_identity_trust,
    idm_rpt_cfg.idmrpt_resource_v idmrpt_resource
     LEFT JOIN idm_rpt_cfg.idmrpt_idv_ent_bindings_v binding ON binding.cat_item_id::text = idmrpt_resource.res_id::text
     LEFT JOIN idm_rpt_cfg.idmrpt_idv_ent_v ent ON binding.ent_id::text = ent.idv_ent_id::text
     LEFT JOIN idm_rpt_cfg.idmrpt_idv_drivers_v driver ON ent.idv_driver_id::text = driver.idv_driver_id::text
     LEFT JOIN idm_rpt_cfg.idmrpt_r_to_res_relationship_v rela ON idmrpt_resource.res_id::text = rela.res_id::text
  WHERE idmrpt_resource.res_id::text = idmrpt_idv_identity_trust.trust_obj_id::text AND idmrpt_rpt_driver.idv_id::text = idmrpt_idv.idv_id::text AND
        CASE
            WHEN idmrpt_resource.rpt_drv_id IS NULL THEN idmrpt_resource.rpt_drv_id IS NULL
            ELSE idmrpt_rpt_driver.rpt_drv_id::text = idmrpt_resource.rpt_drv_id::text
        END AND idmrpt_idv.idv_id::text = idmrpt_resource.idv_id::text AND idmrpt_idv_identity_trust.identity_id::text = idmrpt_identity.identity_id::text AND
        CASE
            WHEN lower(idmrpt_idv_identity_trust.cause_type::text) = lower('role driver'::text) THEN (( SELECT count(1) AS count
               FROM idm_rpt_cfg.idmrpt_idv_identity_trust_v identity_trust
              WHERE identity_trust.trust_obj_id::text = rela.role_id::text AND identity_trust.identity_id::text = idmrpt_idv_identity_trust.identity_id::text)) > 0
            ELSE 1 = 1
        END
  ORDER BY (COALESCE(idmrpt_resource.res_name, idmrpt_resource.res_dn)), (
        CASE
            WHEN lower(idmrpt_idv_identity_trust.cause_type::text) = lower('role driver'::text) THEN (rela.role_name::text || ' -- '::text) || rela.role_descr::text
            ELSE NULL::text
        END), idmrpt_idv_identity_trust.trust_start_time, idmrpt_idv_identity_trust.idmrpt_valid_to, driver.drv_name, (
        CASE
            WHEN binding.ent_param_str::text ~~ '%ID2%'::text THEN ( SELECT idmrpt_ms_ent_cs_v.ms_ent_val_disp_name
               FROM idm_rpt_cfg.idmrpt_ms_ent_cs_v
              WHERE idmrpt_ms_ent_cs_v.ms_ent_val::text = "substring"(binding.ent_param_str::text, "position"(binding.ent_param_str::text, 'ID2'::text) + 6, "position"("substring"(binding.ent_param_str::text, "position"(binding.ent_param_str::text, 'ID2'::text) + 6), '}'::text) - 2))
            WHEN binding.ent_param_str::text ~~ '%ID%'::text THEN ( SELECT idmrpt_ms_ent_cs_v.ms_ent_val_disp_name
               FROM idm_rpt_cfg.idmrpt_ms_ent_cs_v
              WHERE idmrpt_ms_ent_cs_v.ms_ent_val::text = "substring"(binding.ent_param_str::text, "position"(binding.ent_param_str::text, 'ID'::text) + 5, "position"("substring"(binding.ent_param_str::text, "position"(binding.ent_param_str::text, 'ID'::text) + 5), '}'::text) - 2))
            WHEN binding.ent_param_str::text = '%EntitlementParamKey%'::text OR binding.ent_param_val::text = '%EntitlementParamKey%'::text THEN
            CASE
                WHEN idmrpt_idv_identity_trust.trust_params::text ~~ '%ID2%'::text THEN (( SELECT idmrpt_ms_ent_cs_v.ms_ent_val_disp_name
                   FROM idm_rpt_cfg.idmrpt_ms_ent_cs_v
                  WHERE idmrpt_ms_ent_cs_v.ms_ent_val::text = "substring"(idmrpt_idv_identity_trust.trust_params::text, "position"(idmrpt_idv_identity_trust.trust_params::text, 'ID2'::text) + 6, "position"("substring"(idmrpt_idv_identity_trust.trust_params::text, "position"(idmrpt_idv_identity_trust.trust_params::text, 'ID2'::text) + 6), '}'::text) - 2)))::text
                WHEN idmrpt_idv_identity_trust.trust_params::text ~~ '%ID%'::text THEN (( SELECT idmrpt_ms_ent_cs_v.ms_ent_val_disp_name
                   FROM idm_rpt_cfg.idmrpt_ms_ent_cs_v
                  WHERE idmrpt_ms_ent_cs_v.ms_ent_val::text = "substring"(idmrpt_idv_identity_trust.trust_params::text, "position"(idmrpt_idv_identity_trust.trust_params::text, 'ID'::text) + 5, "position"("substring"(idmrpt_idv_identity_trust.trust_params::text, "position"(idmrpt_idv_identity_trust.trust_params::text, 'ID'::text) + 5), '}'::text) - 2)))::text
                ELSE "substring"(idmrpt_idv_identity_trust.trust_params::text, "position"(idmrpt_idv_identity_trust.trust_params::text, 'EntitlementParamKey'::text) + 21, "position"("substring"(idmrpt_idv_identity_trust.trust_params::text, "position"(idmrpt_idv_identity_trust.trust_params::text, 'EntitlementParamKey'::text) + 21), '</value>'::text) - 1)
            END::character varying
            ELSE binding.ent_param_val
        END), binding.ent_param_liid, idmrpt_identity.last_name, idmrpt_identity.first_name, idmrpt_identity.middle_initial;

ALTER TABLE idm_rpt_cfg.IDMRPT_RES_TRUST_V
  OWNER TO idm_rpt_cfg;
GRANT ALL ON TABLE idm_rpt_cfg.IDMRPT_RES_TRUST_V TO idm_rpt_cfg;
GRANT SELECT ON TABLE idm_rpt_cfg.IDMRPT_RES_TRUST_V TO idmrptuser;
